Package Details: mesa-git 21.1.0_devel.135859.a1e9a5d6534-1

Git Clone URL: https://aur.archlinux.org/mesa-git.git (read-only, click to copy)
Package Base: mesa-git
Description: an open-source implementation of the OpenGL specification, git version
Upstream URL: https://www.mesa3d.org
Keywords: mesa X11
Licenses: custom
Conflicts: libva-mesa-driver, mesa, mesa-vdpau, opencl-mesa, vulkan-intel, vulkan-mesa-layer, vulkan-radeon, vulkan-swrast
Provides: libva-mesa-driver, mesa, mesa-vdpau, opencl-driver, opencl-mesa, opengl-driver, vulkan-driver, vulkan-intel, vulkan-mesa-layer, vulkan-radeon, vulkan-swrast
Submitter: Krejzi
Maintainer: Lone_Wolf (rjahanbakhshi)
Last Packager: rjahanbakhshi
Votes: 163
Popularity: 1.27
First Submitted: 2014-06-19 21:33
Last Updated: 2021-03-03 09:02

Dependencies (34)

Required by (1000)

Sources (3)

Pinned Comments

Lone_Wolf commented on 2021-01-03 15:38

I am using another package now and am looking for a new maintainer.

Lone_Wolf commented on 2020-04-23 12:26

Mesa and llvm are closely tied together. Everytime the llvm mesa is built against changes/updates , mesa needs to be rebuilt.

I expect anyone building mesa-git against one of the llvm trunk variants to be able to do that themselves, but atleast some of the people that built against repo llvm don't understand how to deal with such a rebuild.

The rest of this post is meant for those people.

  • Verify if latest PKGBUILD requirements match llvm repo versions.
  • If they don't , post to alert me of this.
  • DELAY the update of llvm/clang suite and their lib32- counterparts
  • Once the PKGBUILD does match, download it.

Option A - best one

  • run pacman -Syu to ensure your system is in sync with your mirrror server
  • build mesa-git in a clean chroot

see https://wiki.archlinux.org/index.php/DeveloperWiki:Building_in_a_clean_chroot for the official way or https://aur.archlinux.org/packages/clean-chroot-manager for an alternative method.

  • install the newly built mesa-git
  • run pacman -Syu
  • ready

Option B - 2nd best

  • revert to repo mesa
  • pacman -Syu
  • build mesa-git
  • switch from mesa to mesa-git
  • ready

Lone_Wolf commented on 2019-07-09 13:43

  • llvm

Why would I want to use llvm development versions ?

For full functionality and latest features mesa trunk master needs to be build against llvm trunk master.
If you build against stable llvm things MAY work, but you're likely to lack some features and face stability issues.

Mesa-git uses a custom environment variable MESA_WHICH_LLVM for flexibility.
It has 4 values.
1 : aur llvm-minimal-git
2 : aur llvm-git
3: llvm-git from LordHeavy' unofficial repo
4: llvm from extra repo

I use value 1 95% of the time and set this in ~/.bash_rc .
If MESA_WHICH_LLVM is unset or empty, the default value of 4 (extra llvm) is used.

AUR helpers like yay and pamac can't deal with such a dynamic choice. People who use those will have to accept the default of building mesa-git against stock repo packages.

Lone_Wolf commented on 2018-01-30 14:06

  • issues
Simple issues can be dealth with through aur comments, but sometimes discussion is needed.
Use https://bbs.archlinux.org/viewtopic.php?id=212819 for that.
  • main difference with stable repo package
[extra]mesa is a split package, but aur mesa-git isn't.
Basically with aur mesa-git you get everything in one package, while [extra]/mesa allows you to leave out some parts if you don't want/need them.
Having a single package reduces maintenance and makes switching from stable to mesa-git rather easy, though reverting back to stable can be tricky.
  • meson settings
Those who compare PKGBUILDs will notice I don't use arch-meson, but meson setup.
I disagree with some of the settings made by arch-meson (especially the buildtype and enabling LTO by default) and feel using meson setup is cleaner.
  • how to update

run pacman Syu update non-repo packages for llvm if you use them

build mesa-git, log out , restart X .

run glxinfo to verify basic OpenGL functionality

build lib32-mesa-git

run glxinfo32 to verify basic OpenGL functionality for multilib programs

Latest Comments

« First ‹ Previous 1 2 3 4 5 6 7 8 ... Next › Last »

Sinistar commented on 2020-12-20 00:49

another option which you probably won't like is to put a shell script in "etc/profile.d" that checks what graphic card vendor is installed.

something like

 if [[ $(lspci) == *"AMD/ATI"* ]]
 then
 export VK_ICD_FILENAMES=/usr/share/vulkan/icd.d/radeon_icd.x86_64.json 
 else 
 export VK_ICD_FILENAMES=/usr/share/vulkan/icd.d/intel_icd.x86_64.json
 fi

just and idea.

Sinistar commented on 2020-12-18 22:10

I use VK_ICD_FILENAMES also (because I use amdvlk for a few games}, but i would guess most are not even aware of it. I am also guessing the main users of this git are gamers, so I would probably disable swrast vulkan.

Lone_Wolf commented on 2020-12-17 10:19

I do recognize there are valid usecases for split packages. gcc and llvm are examples.

My experience with split packages is that they increase complexity and make maintenance and troubleshooting harder.

When I became mesa-git maintainer on 2015-08-07, it was a split package. If you check the changes you'll find many that were needed solely because of the use of a split package.

I created a mesa-git-test package and switched to a single package, then had mesa-git-test merged into mesa-git.

https://aur.archlinux.org/cgit/aur.git/commit/?h=mesa-git&id=b7757495659dbc974eae42aa1b5fa3b58a171c91 was the first singular mesa-git package.

After that switch the maintenance effort needed went down a lot.

Logically speaking if I split off one vulkan driver , I have to split off the other 2 also.

So that's 4 pacakges instead of 1 .

Since mesa upstream does not support splitting their code, I'd have to use the same approach extra/mesa uses :

set DESTDIR to a temporary location and then manually move everything to the subpackage folders where they need to go.

This would increase the maintenance effort again to a level that's to much for for me. All this for something that can be solved by using an environment variable.

I added lavapipe support to mesa-git to stay closer to extra/mesa, not because users asked for it. Disabling it seems to be the simplest solution.

I'll wait a few more days for responses before deciding.

Sinistar commented on 2020-12-17 03:41

Maybe just split out that one package, its only two files. I dont like that they are calling it "vulkan-mesa"

eschwartz commented on 2020-12-15 01:58

https://github.com/Plagman

I'd expect "we" here is Valve Software and "users" are people using multilib/steam.

As a matter of curiosity, what is the problem with split packages? Especially given all the work is done in [extra] already.

Lone_Wolf commented on 2020-12-14 21:08

Having mesa-vulkan / lavapipe installed without the device select layer

mesa-git is built with -D vulkan-device-select-layer=true . Do you mean lavapipe doesn't support it yet ?

Personally I use the VK_ICD_FILENAMES environment var to make sure the right card is used.

extra/mesa does build gallium swrast also by default, it just lets you decide whether to install lavapipe or not.

I'm not going to make mesa-git a split package, maybe you can change the instructions to include setting VK_ICD_FILENAMES ?

I'm a bit puzzled by "Using mesa-git is what we tell users to use" . Please clarify who we and users refer to.

Plagman commented on 2020-12-13 22:10

You probably don't want swrast enabled by default in there unless you follow the same split package structure as the upstream mesa package. Having mesa-vulkan / lavapipe installed without the device select layer will break a normal gaming setup, as a bunch of stuff will pick it up by default. Using mesa-git is what we tell users to use when there's games that need bleeding-edge Mesa fixes to run, like the current Cyberpunk 2077 situation, but our instructions will unfortunately break them now with yesterday's change.

drowfx commented on 2020-12-10 20:26

As of mesa commit ee802372180a ("mesa: Retire classic OSMesa.") the osmesa configuration parameter is a boolean. So -D osmesa=gallium in the PKGBUILD needs to be changes to -D osmesa=true to prevent a "Value gallium is not boolean" error.

Lone_Wolf commented on 2020-11-21 22:33

From my top pinned comment :

Mesa and llvm are closely tied together. Everytime the llvm mesa is built against changes/updates , mesa needs to be rebuilt.

I expect anyone building mesa-git against one of the llvm trunk variants to be able to do that themselves, but atleast some of the people that built against repo llvm don't understand how to deal with such a rebuild.

The rest of this post is meant for those people.

Check the top pinned comment for methods to update cleanly apply that to mesa-git.

AFTER you finished updating mesa-git completely using one of those methods, apply the same method for updating lib32-mesa-git .

deemon commented on 2020-11-21 15:08

Could you pretty please make the dependancies not require specific versions of llvm? or at least make them require >= not just = ??? Can't upgrade anything this way because they just conflict with each other back and forth.

[deemon@Zen ~]$ yay -S mesa-git lib32-mesa-git
:: Checking for conflicts...
:: Checking for inner conflicts...
[Repo:2]  llvm-libs-11.0.0-1  lib32-llvm-libs-11.0.0-1
[Repo Make:3]  llvm-11.0.0-1  clang-11.0.0-1  lib32-llvm-11.0.0-1
[Aur:2]  mesa-git-21.0.0_devel.131029.fe3b5241a48-1  lib32-mesa-git-21.0.0_devel.131029.fe3b5241a48-1

==> Remove make dependencies after install? [y/N] 
  2 mesa-git                         (Installed) (Build Files Exist)
  1 lib32-mesa-git                   (Installed)
==> Packages to cleanBuild?
==> [N]one [A]ll [Ab]ort [I]nstalled [No]tInstalled or (1 2 3, 1-3, ^4)
==> n
:: Downloaded PKGBUILD (1/2): lib32-mesa-git
:: Downloaded PKGBUILD (2/2): mesa-git
:: (1/2) Parsing SRCINFO: mesa-git
:: (2/2) Parsing SRCINFO: lib32-mesa-git
resolving dependencies...
looking for conflicting packages...
error: failed to prepare transaction (could not satisfy dependencies)
:: installing lib32-llvm-libs (11.0.0-1) breaks dependency 'lib32-llvm-libs=10.0.1' required by lib32-mesa-git
:: installing llvm-libs (11.0.0-1) breaks dependency 'llvm-libs=10.0.1' required by mesa-git
error installing repo packages